#include "stdafx.h"
#include "locate_algorithm.h"
#include <math.h>
#include <algorithm>
#include "../common/matrix/_Matrix.h"
#include "../common/Functions/Functions.h"
using namespace std;

// ant ߣ tarλĿ꣬ d 
void AOAformula( struct _coordinate* ant, double angle, struct _coordinate* tar, bool is_line /*= false*/, double z_offset /*= 0*/ )
{
	double aa = sin(angle);
	double bb = cos(angle);
	double h = ant->z;
	if(is_line){
		h = z_offset;
	}
	tar->x = ant->x + sqrt(ant->d * ant->d - h * h) * cos(angle); 
	tar->y = ant->y + sqrt(ant->d * ant->d - h * h) * sin(angle);
	tar->z = ant->z; // ߶
	tar->a = ant->a; // Ƕ
	tar->t = ant->t; // ʱ
	tar->d_offset = ant->d_offset;
	tar->reader_id = ant->reader_id;
	tar->d = ant->d;
}

// ant ߣ last ϴ
double Distanceformula( struct _coordinate* ant, struct _coordinate* last )
{
	double x0,y0;
	double tan_diff = tan(last->a) - tan(ant->a);
	double ret = 0;
	if(tan_diff == 0){
		ret = sqrt((ant->x - last->x) * (ant->x - last->x) +  (ant->y - last->y) * (ant->y - last->y));
	}else{
		x0 = (last->x * tan(last->a) - ant->x * tan(ant->a) + ant->y - last->y) / (tan(last->a) - tan(ant->a));
		y0 = (((last->x - ant->x) * tan(last->a) * tan(ant->a)) + ant->y * tan(last->a) - last->y * tan(ant->a)) / (tan(last->a) - tan(ant->a));
		ret = sqrt((x0 - ant->x) * (x0 - ant->x) + (y0 - ant->y) * (y0 - ant->y)) 
			+ sqrt((x0 - last->x) * (x0 - last->x) + (y0 - last->y) * (y0 - last->y));
	}
	// n = Nodeformula( n1, n2);
	return ret;
}

// յ
void algorithm_locate( struct _coordinate** coor_list, int coor_size, struct _coordinate* hist, struct _coordinate* dest, double dist_limit, double z_offset)
{
	double d0;  //ʷλʵʱλ֮ľ룻
	double dN;  //Vʱۼн룻
	double Angle1,Angle2,Angle3;  //ʱκ2ĽǶ
	double Angle;   //֮ĽǶ
	double dLong;
	double dLenth;
	int position;  //λλ

	switch(coor_size){		
	case 1: // 1λݣ5.3.1
		{
			if(coor_list[0]->d > dist_limit){ // ľĳ̶ֵ,ʱжϴλ߽Ƕһ
				//coor_list[0]->d -= coor_list[0]->d_offset;
				AOAformula(coor_list[0], coor_list[0]->a, dest, true, z_offset);
			}else { // Сĳֵ
				//Vʱۼн
				dN = coor_list[0]->v * (coor_list[0]->t - hist->t);
				//ʵʱλվߣʷλ֮ľ
				d0 = Distanceformula(coor_list[0], hist);
				if(hist->x - coor_list[0]->x == 0){
					Angle = (coor_list[0]->y >= hist->y) ? 90 : 270;
					Angle = Angle * M_PI / 180;
				}else{
					//ʷʵʱվĽǶȣʷλڶλķ
					Angle = atan((hist->y - coor_list[0]->y)/(hist->x - coor_list[0]->x));
				}

				// ʷͬ		
				//λС֮ľ룬˵λλ֮
				if(d0 >= coor_list[0]->d){
					if(dN >= coor_list[0]->d){
						Angle += M_PI;  //ʷ귴
					}
				}else{  
					//λ֮ľ룬˵λλ֮,ֻҪжĸyuλü
					//۽о֮ľ룬˵ʷͬһ򣬷֮ڷ
					if(dN < coor_list[0]->d){ 
						Angle += M_PI;  //ʷ귴
					}
				}
				//coor_list[0]->d -= coor_list[0]->d_offset;
				AOAformula(coor_list[0], Angle, dest, true, z_offset);  //նλ
			}
			break;
		}
	case 2: //2λݣ5.3.2
		{
			//2λзվ()ʷλ֮ĽǶȣԴƳǷһֱϻ߳
			if(coor_list[0]->x == hist->x ){
				Angle1 = (coor_list[0]->y == hist->y) ? 0 : ((coor_list[0]->y > hist->y) ? 90 : 270);
				Angle1 = Angle1 * M_PI / 180;
			}else{
				Angle1 = atan((coor_list[0]->y - hist->y) / (coor_list[0]->x - hist->x)); 
			}
			if(coor_list[1]->x == hist->x ){
				Angle2 = (coor_list[1]->y == hist->y) ? 0 : ((coor_list[1]->y > hist->y)? 90 : 270);
				Angle2 = Angle2 * M_PI / 180;
			}else{
				Angle2 = atan((coor_list[1]->y - hist->y) / (coor_list[1]->x - hist->x)); 
			}
			if(coor_list[1]->x == coor_list[0]->x ){
				Angle3 = (coor_list[1]->y >= coor_list[0]->y) ? 90 : 270; // ڲͬ
				Angle3 = Angle3 * M_PI / 180;
			}else{
				Angle3 = atan((coor_list[1]->y - coor_list[0]->y) / (coor_list[1]->x - coor_list[0]->x)); 
				if(Angle3 > M_PI){
					Angle3 -= M_PI;
				}
				/*if(coor_list[0]->x > coor_list[1]->x)
				Angle3 += M_PI;*/
			}
			//2Ƕͬ180˵һֱ
			//if(coor_list[0]->a == coor_list[1]->a || coor_list[0]->a == coor_list[1]->a + M_PI || coor_list[0]->a == coor_list[1]->a - M_PI){
			if(Angle1 == Angle2 || Angle1 == Angle2 + M_PI || Angle1 == Angle2 - M_PI){
				//ȡֵ֮,̾Ϊλ
				dLong = max(coor_list[0]->d, coor_list[1]->d);
				position = (coor_list[0]->d > coor_list[1]->d) ? 1 : 0;
				dLenth = Distanceformula(coor_list[0], coor_list[1]);
				if(dLong > dLenth){
					Angle = Angle3 + ((position + 1)%2) * M_PI; 
				}else{
					Angle = Angle3 +  position * M_PI;
				}
				//2ľС2еֵ˵λ2࣬
				//ھ̵Ϊλ꣬λǶͬ
				//2ľеκһ˵λ֮䣬ȡһΪλ,λǶǶ෴+180
				// AOAformula(coor_list[position], Angle, dest);  //նλ

				// ݲĽd 
				// x2 - (d2 - ((d1+d2) - (x2-x1))/2) x2  x2 > x1,d1 > d2
				// x1 + (d1 - ((d1+d2) - (x2-x1))/2) x1  x2 > x1,d1 < d2
				// õ (x1 + x2 + d1 - d2)/2
				// ʾd = ((d1 + d2) - abs(x2-x1))/2
				double d_offset;
				if(fabs(coor_list[0]->x - coor_list[1]->x) > fabs(coor_list[0]->y - coor_list[1]->y)){ // ˮƽ
					d_offset = (coor_list[0]->d + coor_list[1]->d - fabs(coor_list[0]->x - coor_list[1]->x))/2;
				}else{ // ֱ
					d_offset = (coor_list[0]->d + coor_list[1]->d - fabs(coor_list[0]->y - coor_list[1]->y))/2;
				}
				dest->d_offset = d_offset;
				coor_list[0]->d_offset = d_offset;
				coor_list[1]->d_offset = d_offset;
				coor_list[position]->d -= d_offset;
				AOAformula(coor_list[position], Angle, dest, true, z_offset);
			}
			//·ʽ
			else {
				dLenth = Distanceformula(coor_list[0], coor_list[1]); //2֮ľ
				if(dLenth > (coor_list[0]->d  + coor_list[1]->d)) { //ȡһΪλοݣ1λ㷨,ο5.3.1
					//ľĳ̶ֵ,ʱжϴλ߽Ƕһ£
					if(coor_list[0]->d > dist_limit){
						AOAformula(coor_list[0], coor_list[0]->a, dest);  //նλ
					}
					//Сĳֵ
					else{
						dN = coor_list[0]->v * ( hist->t - coor_list[0]->t);  //Vʱۼн룻
						d0 = Distanceformula(coor_list[0], hist);  //ʵʱλվߣʷλ֮ľ
						if(hist->x == coor_list[0]->x){
							Angle = (hist->y >= coor_list[0]->y) ? 90 : 270; //ʷʵʱվĽǶȣʷλڶλķ
							Angle = Angle * M_PI / 180;
						}else{
							Angle = atan((hist->y - coor_list[0]->y) / (hist->x - coor_list[0]->x));
						}

						//λС֮ľ룬˵λλ֮
						if(d0 > coor_list[0]->d){
							if(dN >= coor_list[0]->d){
								Angle += M_PI; //ʷ귴
							}
						}
						else{
							//λ֮ľ룬˵λλ֮,ֻҪжĸλü
							//۽о֮ľ룬˵ʷͬһ򣬷֮ڷ
							if(dN < coor_list[0]->d){
								Angle += M_PI;
							}
						}
						AOAformula(coor_list[0], Angle, dest, true, z_offset);  //նλ
					}
				}
				else { //2λ㷨5.3.2				
					//ȡֵ֮,̾Ϊλ
					dLong = max(coor_list[0]->d, coor_list[1]->d);
					position = (coor_list[0]->d > coor_list[1]->d) ? 1 : 0;
					dLenth = Distanceformula(coor_list[0], coor_list[1]);
					//2ľС2еֵ˵λ2࣬
					//ھ̵Ϊλ꣬λǶͬ
					//2ľеκһ˵λ֮䣬ȡһΪλ,λǶǶ෴
					if(dLong > dLenth){
						Angle = Angle3 + ((position + 1)%2) * M_PI; 
					}else{
						Angle = Angle3 +  position * M_PI;
					}
					AOAformula(coor_list[position], Angle, dest, true, z_offset);  //նλ
				}
			}
			break;
		}
	case 3: // 3λݣ㶨λ 
		{
			// ͬһֱϲʹ㶨λ
			locatebycordinate(coor_list, dest);

			break;
		}
	case 4: // 4ݣȡǰ3
		{
			locatebycordinate(coor_list, dest);
			break;
		}
	default:
		{
			dest->x = -1;
			dest->y = -1;
			dest->a = 0;
			break;
		}
	}
}

void locatebycordinate( struct _coordinate** coor_list, struct _coordinate* dest )
{
	double h = 0;
	int i = 0;
	int j = 0;
	double temp = 0;

	double x[3]; // 
	double y[3]; // 
	double z[3];
	double d[3];
	double p[2]; 
	_Matrix pi;

	matrix_set(&pi,3,2);
	matrix_init(&pi);

	for(i=0;i<3;i++){
		x[i] = coor_list[i]->x;
		y[i] = coor_list[i]->y;
		z[i] = coor_list[i]->z;
		d[i] = coor_list[i]->d; // d * CM_PIX * 100;
	}
	//
	matrix_write(&pi,0,0,x[0]);
	matrix_write(&pi,0,1,y[0]);
	h = z[0];
	d[0] = sqrt(d[0] * d[0] - h * h);

	matrix_write(&pi,1,0,x[1]);
	matrix_write(&pi,1,1,y[1]);
	h = z[1];
	d[1] = sqrt(d[1] * d[1]- h * h);

	matrix_write(&pi,2,0,x[2]);
	matrix_write(&pi,2,1,y[2]);
	h = z[2];
	d[2] = sqrt(d[2] * d[2] - h * h);

	if (locate(&pi,d,p) > 0)
	{
		dest->x = p[0];
		dest->y = p[1];
	}else
	{
		dest->x = -1;
		dest->y = -1;
	}
}

void algorithm_locate_ex( _coordinate** coor_list, int coor_size, _coordinate* hist, _coordinate* dest, double dist_limit )
{
	switch (coor_size)
	{
	case 1:
		{
			if(!hist){ // μ㣬ֻһվݵʱ
				return;
			}
			// ȡʷڵ뵱ǰվĽǶȣжǷͬһֱ
			double angle = getAngleByAngle(coor_list[0], hist);
			if(0 == tan(angle)){ // ͬһֱ
				double dist_temp = getDistance(hist, coor_list[0]); // һεľ
				// ƶľ
				double dist_mv = fabs(dist_temp - coor_list[0]->d);
				// ԭƶ˶
				calcCoordinate(hist, dist_mv, hist->a, dest); //
			}else{ // нǶȣҽ
				_coordinate* pt_cross = getCross(hist, coor_list[0]);
				double dist_temp = getDistance(pt_cross, coor_list[0]);
				if(dist_temp >= coor_list[0]->d){
					// ⶯ǽȽõ㶨λ
					dest->x = pt_cross->x;
					dest->y = pt_cross->y;
					dest->z = coor_list[0]->z;
					dest->a = getAngleByCoordinate(pt_cross, coor_list[0]); // з
				}else{ // ڵǰ, ϲ
					dist_temp = (getDistance(hist, pt_cross) - (coor_list[0]->d - dist_temp)); // λ
					calcCoordinate(hist, dist_temp, hist->a, dest);
				}
			}
			break;
		}
	case 2:
		{
			double angle_anc = getAngleByAngle(coor_list[0], coor_list[1]);
			if(0 == tan(angle_anc)){ // ͬһֱ
				double dist_anc = getDistance(coor_list[0], coor_list[1]);
				double dist_offset;
				if(dist_anc < coor_list[0]->d || dist_anc < coor_list[1]->d ) {//վʶľڷվ֮ľ룬ͬһ
					dist_offset = fabs(coor_list[0]->d - coor_list[1]->d) - dist_anc;
					double angle_anc_run = getAngleByCoordinate(coor_list[0], coor_list[1]); // վ2һ
					if(coor_list[0]->d < coor_list[1]->d){ // վ1һ
						angle_anc_run += M_PI;
					}
					calcCoordinate(coor_list[0], coor_list[0]->d - dist_offset / 2, angle_anc_run, dest);
				}else{ //ڷվ֮
					dist_offset = coor_list[0]->d + coor_list[1]->d - dist_anc;
					calcCoordinate(coor_list[0], coor_list[0]->d + dist_offset / 2, getAngleByCoordinate(coor_list[0], coor_list[1]), dest);
				}
			}else{ // мн, һվ֮
				if(hist){
					double angle_anc1 = getAngleByAngle(coor_list[0], hist);
					double angle_anc2 = getAngleByAngle(coor_list[1], hist);
					// ҵ
					_coordinate* pt_cross = getCross(coor_list[0], coor_list[1]);
					// 㵽վľ
					double dist_anc1 = getDistance(pt_cross, coor_list[0]);
					double dist_anc2 = getDistance(pt_cross, coor_list[1]);

					if(0 == tan(angle_anc1)){
						if(dist_anc1 >= coor_list[0]->d){ // ֱΪ׼
							calcCoordinate(hist, fabs(dist_anc1 - coor_list[0]->d), hist->a, dest);
							//calcCoordinate(coor_list[0], coor_list[0]->d, getAngleByCoordinate(coor_list[0], hist), dest);
						}else{ // ֱӶλ
							dest->x = pt_cross->x;
							dest->y = pt_cross->y;
							dest->a = getAngleByCoordinate(pt_cross, coor_list[1]);
						}
					}else if(0 == tan(angle_anc2)){ // վ1ͬһֱ
						if(dist_anc2 >= coor_list[1]->d){ // ֱΪ׼
							calcCoordinate(hist, fabs(dist_anc2 - coor_list[1]->d), hist->a, dest);
							//calcCoordinate(coor_list[1], coor_list[1]->d, getAngleByCoordinate(coor_list[1], hist), dest);
						}else{ // ֱӶλ
							dest->x = pt_cross->x;
							dest->y = pt_cross->y;
							dest->a = getAngleByCoordinate(pt_cross, coor_list[0]);
						}
					}else { // 
						// ҵ
						_coordinate* pt_cross1 = getCross(hist, coor_list[0]);
						_coordinate* pt_cross2 = getCross(hist, coor_list[1]);

						if(coor_list[0]->d >= coor_list[1]->d){
							dest->x = pt_cross2->x;
							dest->y = pt_cross2->y;							
							dest->z = coor_list[1]->z;
							dest->a = coor_list[1]->a;
						}else{
							dest->x = pt_cross1->x;
							dest->y = pt_cross1->y;							
							dest->z = coor_list[0]->z;
							dest->a = coor_list[0]->a;
						}
					}
				}else{ // ȶλ,⴩ǽ
					_coordinate* pt_cross = getCross(coor_list[0], coor_list[1]);
					dest->x = pt_cross->x;
					dest->y = pt_cross->y;
					// ȽϾ,λķ
					if(fabs(getDistance(pt_cross, coor_list[0]) - coor_list[0]->d) >= fabs(getDistance(pt_cross, coor_list[1]) - coor_list[1]->d)){
						dest->z = coor_list[1]->z;
						dest->a = coor_list[1]->a;
					}else{
						dest->z = coor_list[0]->z;
						dest->a = coor_list[0]->a;
					}
				}
			}
			break;
		}
	case 3:
		{
			// жϷվǷͬһֱ
			if(is_all_inline(coor_list, coor_size)){
				algorithm_locate_ex(coor_list, 2, hist, dest, dist_limit);
				break;
			}
			locatebycordinate(coor_list, dest);
			break;
		}
	case 4:
		{
			// жϷվǷͬһֱ
			if(is_all_inline(coor_list, coor_size)){
				algorithm_locate_ex(coor_list, 2, hist, dest, dist_limit);
				break;
			}
			locatebycordinate(coor_list, dest);
			break;
		}
	default:
		break;
	}
}

double getAngleByAngle( _coordinate* p1, _coordinate* p2 )
{
	if(p1->x == p2->x) return 0;
	if(p1->y == p2->y) return 0;
	return double(p2->a - p1->a);
}

double getAngleByCoordinate( _coordinate* p1, _coordinate* p2 )
{
	if(p1->x == p2->x && p1->y == p2->y){ // ȣԽ۷
		return p1->a;
	}
	if(p1->x == p2->x){
		if(p1->y >= p2->y){
			return M_PI_2 * 3;
		}
		return M_PI_2;
	}
	if(p1->y == p2->y){
		if(p1->x > p2->x){
			return M_PI;
		}
		return 0;
	}
	return atan((p2->y - p1->y) / (p2->x - p1->x));
}

_coordinate* getCross( _coordinate* p1, _coordinate* p2 )
{
	_coordinate* p = new _coordinate; 
	double b1 = p1->y - tan(p1->a) * p1->x;
	double b2 = p2->y - tan(p2->a) * p2->x;

	if(p1->a == 0 || p1->a == M_PI){ // һˮƽ
		p->y = p1->y;
		if(p2->a == M_PI_2 || p2->a == M_PI_2 * 3){ // ڶ㴹ֱ
			p->x = p2->x;
		}else{ // ڶнǶ
			p->x = (p->y - b2) / tan(p2->a);
		}
		return p;
	}else if(p1->a == M_PI_2 || p1->a == M_PI_2 * 3){ // һ㴹ֱ
		p->x = p1->x;
		if(p2->a == 0 || p2->a == M_PI){ // ڶˮƽ
			p->y = p2->y;
		}else{ // ڶнǶ
			p->y = tan(p2->a) * p->x + b2;
		}
		return p;
	}else { // нǶ
		if(p2->a == 0 || p2->a == M_PI){ // ڶˮƽ
			p->y = p2->y;
			p->x = (p->y - b1) / tan(p1->a);
			return p;
		}else if(p2->a == M_PI_2 || p2->a == M_PI_2 * 3){ // ڶ㴹ֱ
			p->x = p2->x;
			p->y = p->x * tan(p1->a) + b1;
			return p;
		}
	}
	p->x = (b1-b2)/(tan(p2->a) - tan(p1->a));
	p->y = tan(p1->a) * p->x + b1;
	return p;
}

// ۷
void calcCoordinate( _coordinate* p1, double dist, double angle, _coordinate* dest )
{
	dest->x = p1->x;
	dest->y = p1->y;
	dest->z = p1->z;

	dest->x += dist * cos(angle);
	dest->y += dist * sin(angle);

	dest->a = angle;
}

double getDistance( _coordinate* p1, _coordinate *p2 )
{
	return sqrt(pow(p1->x - p2->x, 2) + pow(p1->y - p2->y, 2));
}

bool is_all_inline( _coordinate** coor_list, int cnt )
{
	bool ret = false;
	if(cnt < 3) return ret;
	if(coor_list[0]->x == coor_list[1]->x && coor_list[0]->x == coor_list[2]->x){
		ret = true;
	}else if(coor_list[0]->y == coor_list[1]->y && coor_list[0]->y == coor_list[2]->y){
		ret = true;
	}else{
		ret = false;
	}	
	return ret;
}

//㷨 2016-09-12
/*POS* TOFLocateAlgorithm::Pos(STATION *s,int sta_num,int ant,double dist,INFO_PRE info_pre)
{
	POS* p = new POS;
	p->posx = 0;
	p->posy = 0;
	p->pos_radius = 999999.9; //infmatlabбʾ

	double d[2];
	double xcross[2];
	double ycross[2];

	//size(station(sta_num).px,2)ΪȡpxstationpxҪô2Ҫô3
	int seg_num = 0;
	seg_num = s[sta_num].nRealCalcPoints - 1;

	if(seg_num < 0 ){
		return NULL;
	}

	int j = 0;
	for(int i =0;i<seg_num;i++){

		if(s[sta_num].px[i]==-1||s[sta_num].px[i+1]==-1)
		{
			continue;
		}

		RESULT *r = NULL;
		r = GetPos(s,sta_num,ant,dist,i);
		
		//r = &g_result;
		if(r == NULL){
			continue;
		}
		//r = &result;
		//xcountȡ2ΪΪ2
		int count = 2; 
		for(j =0;j<2;j++){
			xcross[j] = r->x[j];
			ycross[j] = r->y[j];
		}

		for(j = 0;j < count;j++){
			double d1 = xcross[j] - s[info_pre.sta_num].x[info_pre.ant];
			double d2 = ycross[j] - s[info_pre.sta_num].y[info_pre.ant];
			d[j] = sqrt(pow(d1,2) + pow(d2,2));
		}
		for(j = 0;j < count;j++){
			d[j] = fabs(d[j] - info_pre.dist);
		}

		double c = 999999.9;
		int k = -1;
		for(j = 0;j < count;j++){
			if(d[j] < c){
				c = d[j];
				k = j;
			}
		}

		if(c<p->pos_radius){
			p->posx = xcross[k];
			p->posy = ycross[k];
			p->pos_radius = c;
		}
	}

	return p;
}

RESULT* TOFLocateAlgorithm::GetPos(STATION *s,int sta_num,int ant,double dist,int i)
{
	double x1 = 0.0;
	double y1 = 0.0;
	double x2 = 0.0;
	double y2 = 0.0;

	double deta = 0.0;  //b^2 - 4*a*c;
	int count = 0;	//̽ĸ

	if((s[sta_num].px[i] - s[sta_num].px[i+1]) == 0){
		//һĽ
		x1 = s[sta_num].px[i];
		y1 = s[sta_num].y[ant] - dist;
		x2 = s[sta_num].px[i];
		y2 = dist + s[sta_num].y[ant];
		count = 2;
	}else{
		//б
		double k = (s[sta_num].py[i] - s[sta_num].py[i+1])/(s[sta_num].px[i] - s[sta_num].px[i+1]);

		//̶
		//ȷ
		//ԲΪs[sta_num].x[ant],s[sta_num].y[ant];
		double a = pow(k,2) + 1;
		double b = 2*(k*(s[sta_num].py[i] - k*s[sta_num].px[i] - s[sta_num].y[ant])- s[sta_num].x[ant]);
		double d = s[sta_num].py[i] - k * s[sta_num].px[i] - s[sta_num].y[ant]; 
		double c = pow(s[sta_num].x[ant],2) + pow(d,2) - pow(dist,2);

		//deta = b^2 - 4*a*c жϷǷн
		deta = pow(b,2) - 4*a*c; //
		if(deta>0){
			count = 2;
		}else if(deta == 0){
			count = 1;
		}
		else{
			count = 0;
		}

		if(count == 0){
			return NULL;
		}

		//
		//deta = pow(b,2) - 4*a*c; //
		x1 = -(b + sqrt(deta))/(2*a);
		x2 = (-b + sqrt(deta) )/(2*a);
		y1 = k*x1 + s[sta_num].py[i] - k*s[sta_num].px[i];
		y2 = k*x2 + s[sta_num].py[i] - k*s[sta_num].px[i];
	}

	double x[3] = {0,0,0};
	double y[3] = {0,0,0};
	
	x[0] = x1;
	x[1] = x2;
	y[0] = y1;
	y[1] = y2;

	if(count>0){
		for(int t = 0;t<count;t++){
			if(x[t] < min(s[sta_num].px[i],s[sta_num].px[i+1]) - 0.01
				||x[t] > max(s[sta_num].px[i],s[sta_num].px[i+1]) + 0.01
				||y[t] < min(s[sta_num].py[i],s[sta_num].py[i+1])
				||y[t] > max(s[sta_num].py[i],s[sta_num].py[i+1])){
				x[t] = 0;
				y[t] = 0;
			}
		}
	}

	RESULT* result = new RESULT;
	memset(result->x,0,3*sizeof(double));
	memset(result->y,0,3*sizeof(double));
	result->x[0] = x[0];
	result->x[1] = x[1];
	result->y[0] = y[0];
	result->y[1] = y[1];

	return result;
}*/

POS* LocateAlgorithm::Pos(ReaderPathMap rpm,int sta_num,int ant,double dist,INFO_PRE info_pre)
{
	POS* p = new POS;
	p->posx = 0;
	p->posy = 0;
	p->pos_radius = 999999.9; //infmatlabбʾ

	double d[2];
	double xcross[2];
	double ycross[2];

	//size(station(sta_num).px,2)ΪȡpxstationpxҪô2Ҫô3
	int seg_num = 0;
	//seg_num = s[sta_num].nRealCalcPoints - 1;
	seg_num = rpm.find(sta_num)->second->nRealCalcPoints - 1;

	if(seg_num < 0 ){
		return NULL;
	}

	int j = 0;
	for(int i =0;i<seg_num;i++){

		if(rpm.find(sta_num)->second->px[i]==-1||rpm.find(sta_num)->second->px[i+1]==-1)
		{
			continue;
		}

		RESULT *r = NULL;
		r = GetPos(rpm,sta_num,ant,dist,i);
		
		//r = &g_result;
		if(r == NULL){
			continue;
		}
		//r = &result;
		//xcountȡ2ΪΪ2
		int count = 2; 
		for(j =0;j<2;j++){
			xcross[j] = r->x[j];
			ycross[j] = r->y[j];
		}

		for(j = 0;j < count;j++){
			double d1 = xcross[j] - rpm.find(info_pre.sta_num)->second->x[info_pre.ant];
			double d2 = ycross[j] - rpm.find(info_pre.sta_num)->second->y[info_pre.ant];
			d[j] = sqrt(pow(d1,2) + pow(d2,2));
		}
		for(j = 0;j < count;j++){
			d[j] = fabs(d[j] - info_pre.dist);
		}

		double c = 999999.9;
		int k = -1;
		for(j = 0;j < count;j++){
			if(d[j] < c){
				c = d[j];
				k = j;
			}
		}

		if(c<p->pos_radius){
			p->posx = xcross[k];
			p->posy = ycross[k];
			p->pos_radius = c;
		}
	}

	return p;
}

RESULT* LocateAlgorithm::GetPos(ReaderPathMap rpm,int sta_num,int ant,double dist,int i)
{
	double x1 = 0.0;
	double y1 = 0.0;
	double x2 = 0.0;
	double y2 = 0.0;

	double deta = 0.0;  //b^2 - 4*a*c;
	int count = 0;	//̽ĸ

	if((rpm.find(sta_num)->second->px[i] - rpm.find(sta_num)->second->px[i+1]) == 0){
		//һĽ
		x1 = rpm.find(sta_num)->second->px[i];
		y1 = rpm.find(sta_num)->second->y[ant] - dist;
		x2 = rpm.find(sta_num)->second->px[i];
		y2 = dist + rpm.find(sta_num)->second->y[ant];
		count = 2;
	}else{
		//б
		double k = (rpm.find(sta_num)->second->py[i] - rpm.find(sta_num)->second->py[i+1])/(rpm.find(sta_num)->second->px[i] - rpm.find(sta_num)->second->px[i+1]);

		//̶
		//ȷ
		//ԲΪs[sta_num].x[ant],s[sta_num].y[ant];
		double a = pow(k,2) + 1;
		double b = 2*(k*(rpm.find(sta_num)->second->py[i] - k*rpm.find(sta_num)->second->px[i] - rpm.find(sta_num)->second->y[ant])- rpm.find(sta_num)->second->x[ant]);
		double d = rpm.find(sta_num)->second->py[i] - k * rpm.find(sta_num)->second->px[i] - rpm.find(sta_num)->second->y[ant]; 
		double c = pow(rpm.find(sta_num)->second->x[ant],2) + pow(d,2) - pow(dist,2);

		//deta = b^2 - 4*a*c жϷǷн
		deta = pow(b,2) - 4*a*c; //
		if(deta>0){
			count = 2;
		}else if(deta == 0){
			count = 1;
		}
		else{
			count = 0;
		}

		if(count == 0){
			return NULL;
		}

		//
		//deta = pow(b,2) - 4*a*c; //
		x1 = -(b + sqrt(deta))/(2*a);
		x2 = (-b + sqrt(deta) )/(2*a);
		y1 = k*x1 + rpm.find(sta_num)->second->py[i] - k*rpm.find(sta_num)->second->px[i];
		y2 = k*x2 + rpm.find(sta_num)->second->py[i] - k*rpm.find(sta_num)->second->px[i];
	}

	double x[3] = {0,0,0};
	double y[3] = {0,0,0};
	
	x[0] = x1;
	x[1] = x2;
	y[0] = y1;
	y[1] = y2;

	if(count>0){
		for(int t = 0;t<count;t++){
			if(x[t] < min(rpm.find(sta_num)->second->px[i],rpm.find(sta_num)->second->px[i+1]) - 0.01
				||x[t] > max(rpm.find(sta_num)->second->px[i],rpm.find(sta_num)->second->px[i+1]) + 0.01
				||y[t] < min(rpm.find(sta_num)->second->py[i],rpm.find(sta_num)->second->py[i+1])
				||y[t] > max(rpm.find(sta_num)->second->py[i],rpm.find(sta_num)->second->py[i+1])){
				x[t] = 0;
				y[t] = 0;
			}
		}
	}

	RESULT* result = new RESULT;
	memset(result->x,0,3*sizeof(double));
	memset(result->y,0,3*sizeof(double));
	memset(result->z,0,3*sizeof(double));
	result->x[0] = x[0];
	result->x[1] = x[1];
	result->y[0] = y[0];
	result->y[1] = y[1];
	result->z[0] = 0;
	result->z[1] = 0;

	return result;
}

/*
 * TDOA㷨ʵ
 * Pos
 *		
 * param
 *		pRdm	------		ŲķվϢҪϢͬʱ
 *	    trpm    ------		ͼ
 *
 * return
 *	    ս
 *
*/
POS* LocateAlgorithm::Pos(ReceiveDataMap* pRdm,TDOAReaderPathMap trpm)
{
	POS *pos = NULL;
	pos = new POS;
	/*pos->posx = 0;
	pos->posy = 0;
	pos->posz = 0;
	pos->pos_radius = 0;
	pos->dFirstDiff = INVALID_COORDINATE;
	pos->dSecondDiff = INVALID_COORDINATE;
	pos->nFirstReader = INVALID_COORDINATE;
	pos->nSecondReader = INVALID_COORDINATE;*/

	double a = 0;
	double ref_dist = 0.0;   //վ֮·ľ
	
	const int Totals = 2;
	_coordinate res[Totals];
	int res_idx = 0;
	for(int i = 0;i < Totals;i++){
		res[0].x = INVALID_COORDINATE;
		res[0].y = INVALID_COORDINATE;
		res[0].z = INVALID_COORDINATE;
	}

	bool bFirst = true;
	int nNoReaderPathIdx = 0;
	int nFirstReader[Totals] = {-1};
	int nSecondReader[Totals] ={-1};

	//洢·վid
	//ReceiveData* tmp_reader = new ReceiveData[Totals];
	ReceiveData tmp_reader[Totals];

	//洢͵һվ·ķվϢ
	ReceiveData tmp_dist_reader[Totals];
	int nDistReaders = 0;

	ReceiveDataMap::iterator first = pRdm->begin();
	//for(ReceiveDataMap::iterator first = pRdm->begin();first!=pRdm->end();++first){///11
		//ReceiveDataMap::iterator second = pRdm->begin();
	ReceiveDataMap::iterator second = first;
	//ƫƵڶԪ
	std::advance(second,1);

	//ȡһʱ
	ReceiveData f1;
	f1.antenna_id = first->second.antenna_id;
	f1.reader_id = first->second.reader_id;
	f1.rec_time_stamp = first->second.rec_time_stamp;
	f1.x = first->second.x;
	f1.y = first->second.y;
	f1.z = first->second.z;

	//ӵڶʼ
	for(;second != pRdm->end();++second){
		//ȡڶʱ
		ReceiveData f2;
		f2.antenna_id = second->second.antenna_id;
		f2.reader_id = second->second.reader_id;
		f2.rec_time_stamp = second->second.rec_time_stamp;
		f2.x = second->second.x;
		f2.y = second->second.y;
		f2.z = second->second.z;

		//ʱ쳣
		if(f1.rec_time_stamp == LLONG_MAX || f2.rec_time_stamp == LLONG_MAX){
			continue;
		}

		if(f1.reader_id == f2.reader_id){
			continue;
		}

		ReaderPathMap::iterator rpm_it = trpm.find(f1.reader_id)->second->find(f2.reader_id);
		if(rpm_it == trpm.find(f1.reader_id)->second->end()){
			continue;
		}else{
			//͵һվڵͼ
			tmp_dist_reader[nDistReaders].reader_id = f2.reader_id;
			tmp_dist_reader[nDistReaders].x = f2.x;
			tmp_dist_reader[nDistReaders].y = f2.y;
			tmp_dist_reader[nDistReaders].z = f2.z;
			tmp_dist_reader[nDistReaders].rec_time_stamp = f2.rec_time_stamp;
			nDistReaders++;
		}

		//ݾжϼλȡʱʹ
		int nSign = 1;
		long long diffTime = f1.rec_time_stamp - f2.rec_time_stamp;

		//λ
		double dist = CFunctions::getDistance(diffTime,CFunctions::TDOA);

		double readers_dist = sqrt(pow(f1.x - f2.x,2) + pow(f1.y - f2.y,2));

		if(fabs(dist) - readers_dist > 0){
			continue;
		}

		//ҵм򣬱ûд·ͼ
		TDOAReaderPathMap::iterator rdm_it = trpm.find(f1.reader_id);
		if(rdm_it == trpm.end()){
			continue;
		}

		//ȡͼ·
		ReaderPath * pRP = trpm.find(f1.reader_id)->second->find(f2.reader_id)->second;
		ReaderPath pRP2 = *trpm.find(f1.reader_id)->second->find(f2.reader_id)->second;

		tmp_reader[nNoReaderPathIdx].reader_id = f2.reader_id;
		tmp_reader[nNoReaderPathIdx].x = f2.x;
		tmp_reader[nNoReaderPathIdx].y = f2.y;
		tmp_reader[nNoReaderPathIdx].z = f2.z;
		tmp_reader[nNoReaderPathIdx].rec_time_stamp = f2.rec_time_stamp;
		nNoReaderPathIdx++;

		//վ֮߶θ
		int seg_num = pRP->nRealCalcPoints - 1;

		if(seg_num == 0 || seg_num > 100){
			continue;
		}

		//Ϊ˫վ֮i߶λߵj߶ηֱ
		//߷վ֮һֱߣ
		double xcross[2] = {INVALID_COORDINATE,INVALID_COORDINATE};
		double ycross[2] = {INVALID_COORDINATE,INVALID_COORDINATE};
		double zcross[2] = {INVALID_COORDINATE,INVALID_COORDINATE};

		int nIdx = 0;

		//߶θʼ
		for(int i = 0;i < seg_num;i++){
			RESULT * r = NULL;

			//λ꣬˫ߺ߶ཻĽ
			r = LocateAlgorithm::GetPos(pRP,dist,i);

			//޽Ч
			if(r == NULL ){
				continue;
			}
			if(r->nCount == 0){
				delete r;
				r = NULL;
				continue;
			}

			/*nFirstReader = f1.reader_id;
			nSecondReader = f2.reader_id;*/

			if(r->nCount == 1){
				xcross[nIdx] = r->x[0];
				ycross[nIdx] = r->y[0];
				nIdx++;
			}
			if(r->nCount == 2){
				for(int j = 0; j < 2;j++){
					xcross[j] = r->x[j];
					ycross[j] = r->y[j];
					nIdx++;
				}
				if(r){
					delete r;
					r = NULL;
				}
			}

			if(nIdx == 2){
				//⵽֮ľ
				double deltad[2] = {0};
				for(int j = 0; j < 2;j ++){
					double d[2] = {0};
					double dx1 = xcross[j] - pRP->x[0];
					double dy1 = ycross[j] - pRP->y[0];
					d[0] = sqrt(pow(dx1,2) + pow(dy1,2));

					double dx2 = xcross[j] - pRP->x[1];
					double dy2 = ycross[j] - pRP->y[1];
					d[1] = sqrt(pow(dx2,2) + pow(dy2,2));

					deltad[j] = d[0] - d[1];
				}

				int idx = 0;	

				//Ӧú֮ǰdistͬ
				if(dist > 0){
					for(int j = 0;j < 2;j++){
						if(deltad[j] > 0){
							idx = j;
							break;
						}
					}	
				}else{
					for(int j = 0;j < 2;j++){
						if(deltad[j] < 0){
							idx = j;
							break;
						}
					}	
				}
				nFirstReader[res_idx]  = f1.reader_id;
				nSecondReader[res_idx] = f2.reader_id;

				res[res_idx].x = xcross[idx];
				res[res_idx].y = ycross[idx];
				res[res_idx].z = zcross[idx];
				res_idx++;
			}		

			if(r){
				delete r;
				r = NULL;
			}
			continue;
		}
	}


	_coordinate r;
	r.x = INVALID_COORDINATE;
	r.y = INVALID_COORDINATE;
	r.z = INVALID_COORDINATE;

	if(res_idx == 1){
		bool bValid = true;

		//λڷվҪжϴ˷վǷΪspecialΪspecialܴ˶λ
		for(ReceiveDataMap::iterator it = pRdm->begin();it!=pRdm->end();++it){
			double dist = sqrt(pow(res[0].x - it->second.x,2) + pow(res[0].y - it->second.y,2));	
			if(dist<4){
				if(it->second.special == 0){
					bValid = false;
				}
			}
		}

		if(pRdm->size()>=3&&bValid){
			/*ReceiveDataMap::iterator it = pRdm->begin();
			ReceiveDataMap::iterator f_it = pRdm->end();
			int k = 0;
			int readersNo[2] = {0};
			readersNo[0] = nFirstReader[0];
			readersNo[1] = nSecondReader[0];*/

			//ҳûв붨λһվϢ
			//ReceiveData rd;
			//bool isExist = false;
			//for(it;it!=pRdm->end();++it){
			//	for(int i=0;i<2;i++){
			//		if(it->first == readersNo[i]){
			//			f_it = pRdm->end();
			//			isExist = false;
			//			break;
			//		}else{
			//			isExist = true;
			//		}
			//	}
			//	if(isExist){
			//		//
			//		rd.reader_id = it->first;
			//		rd.rec_time_stamp = it->second.rec_time_stamp;
			//		rd.antenna_id = it->second.antenna_id;
			//		rd.special = it->second.special;
			//		rd.x = it->second.x;
			//		rd.y = it->second.y;
			//		rd.z = it->second.z;
			//	}
			//}

			double dist[2] = {0};
			//㶨λ붨λ֮һķվδ붨λķվ֮ľ
			//Ƚϴ˾
			//if(rd.reader_id!=0){
			//	ReceiveDataMap::iterator it = pRdm->find(nFirstReader[0]);

			//	dist[0] = sqrt(pow(res[0].x - it->second.x,2) + pow(res[0].y - it->second.y,2));
			//	dist[1] = sqrt(pow(res[0].x - rd.x,2) + pow(res[0].y - rd.y,2));

			//	double dif1 = fabs(dist[0] - dist[1]);

			//	double dt = it->second.rec_time_stamp - rd.rec_time_stamp;
			//	double dif2 = fabs(CFunctions::getDistance(dt,CFunctions::TDOA));

			//	double dif = fabs(dif1 - dif2);

			//	if(dif>10){//4
			//		bValid = false;
			//	}	
			//}
			//ж¶λ붨λվľ


			//2016/12/06 ѡȡվʽ:
			//ѡȡ͵һվеͼվб
			//磺վ˳21,3У1,2ͣ2,3֮еͼôѡȡ1,3б
			//վ˳1,23У12еͼ(1,3)֮޵ͼôʱͲʹ·б
			if(nDistReaders == 2){
				dist[0] = sqrt(pow(res[0].x - tmp_dist_reader[0].x,2) + pow(res[0].y - tmp_dist_reader[0].y,2));
				dist[1] = sqrt(pow(res[0].x - tmp_dist_reader[1].x,2) + pow(res[0].y - tmp_dist_reader[1].y,2));

				double dif1 = fabs(dist[0] - dist[1]);

				double dt = tmp_dist_reader[0].rec_time_stamp - tmp_dist_reader[1].rec_time_stamp;
				double dif2 = fabs(CFunctions::getDistance(dt,CFunctions::TDOA));

				double dif = fabs(dif1 - dif2);

				if(dif>10){//4
					bValid = false;
				}	
			}
		}

		if(bValid){
			r.x = res[0].x;
			r.y = res[0].y;
			r.z = res[0].z;
			pos->dFirstDiff = 0.0;
			pos->dSecondDiff = 0.0;
		}
	}

	int r_idx = 0;

	if(res_idx >= 2){
		double d = 99999.9;
		
		long long dt = tmp_reader[0].rec_time_stamp - tmp_reader[1].rec_time_stamp;
		//λ
		double ref_dist = CFunctions::getDistance(dt,CFunctions::TDOA);

		double diff[2] = {0};
		for(int i = 0;i<res_idx;i++){//2
			double d_tmp = sqrt(pow(res[i].x - tmp_reader[0].x,2) + pow(res[i].y - tmp_reader[0].y,2)) - sqrt(pow(res[i].x - tmp_reader[1].x,2) + pow(res[i].y - tmp_reader[1].y,2));
			double d_diff = abs(d_tmp - ref_dist);
			switch(i){
			case 0:
				pos->dFirstDiff = d_diff;
				break;
			case 1:
				pos->dSecondDiff = d_diff;
				break;
			}
			diff[i] = d_diff;
			if(d_diff < d){
				d = d_diff;
				r_idx = i;
			}
		}

		if(pRdm->size()>=3){
			if(diff[r_idx] < 4){
				r.x = res[r_idx].x;
				r.y = res[r_idx].y;
				r.z = res[r_idx].z;
			}
		}
	}

	//յõĽ
	pos->posx = r.x;
	pos->posy = r.y;
	//pos->posz = res.z;
	pos->posz = 0;

	if(pos->posx != INVALID_COORDINATE && pos->posy != INVALID_COORDINATE){
		pos->nFirstReader = nFirstReader[r_idx];
		pos->nSecondReader = nSecondReader[r_idx];
	}

	return pos;
}

POS* LocateAlgorithm::Pos(POS* pos,TDOAReaderPathMap trpm)
{
	if(trpm.find(pos->nFirstReader) == trpm.end()){
		return NULL;
	}
	if(trpm.find(pos->nFirstReader)->second->find(pos->nSecondReader)==trpm.find(pos->nFirstReader)->second->end()){
		return NULL;
	}

	POS *p = NULL;
	p = new POS;
	p->posx = pos->posx;
	p->posy = pos->posy;
	p->posz = pos->posz;
	p->pos_radius = pos->pos_radius;
	p->nFirstReader = pos->nFirstReader;
	p->nSecondReader = pos->nSecondReader;

	_coordinate res[2];
	int res_idx = 0;
	for(int i = 0;i < 2;i++){
		res[i].x = INVALID_COORDINATE;
		res[i].y = INVALID_COORDINATE;
		res[i].z = INVALID_COORDINATE;
	}

	//
	double distance = 0.0;

	distance = sqrt(pow(p->posx - trpm.find(pos->nFirstReader)->second->find(pos->nSecondReader)->second->x[0],2 ) + pow(p->posy - trpm.find(pos->nFirstReader)->second->find(pos->nSecondReader)->second->y[0],2 )) - 
		sqrt(pow(p->posx - trpm.find(pos->nFirstReader)->second->find(pos->nSecondReader)->second->x[1],2 ) + pow(p->posy - trpm.find(pos->nFirstReader)->second->find(pos->nSecondReader)->second->y[1],2 ));

	//ȡͼ·
	ReaderPath * pRP = trpm.find(pos->nFirstReader)->second->find(pos->nSecondReader)->second;

	//վ֮߶θ
	int seg_num = pRP->nRealCalcPoints - 1;

	if(seg_num == 0){
		return NULL;
	}

	double xcross[2] = {INVALID_COORDINATE,INVALID_COORDINATE};
	double ycross[2] = {INVALID_COORDINATE,INVALID_COORDINATE};
	double zcross[2] = {INVALID_COORDINATE,INVALID_COORDINATE};

	int nIdx = 0;
	int nResIdx = 0;

	for(int i = 0;i < seg_num;i++){
		RESULT * r = NULL;

		//λ꣬˫ߺ߶ཻĽ
		r = GetPos(pRP,distance,i);

		//޽Ч
		if(r == NULL ){
			continue;
		}
		if(r->nCount == 0){
			delete r;
			r = NULL;
			continue;
		}

		if(r->nCount == 1){
			xcross[nIdx] = r->x[0];
			ycross[nIdx] = r->y[0];
			nIdx++;
		}
		if(r->nCount == 2){
			for(int j = 0; j < 2;j++){
				xcross[j] = r->x[j];
				ycross[j] = r->y[j];
				nIdx++;
			}
			if(r){
				delete r;
				r = NULL;
			}
		}

		if(nIdx == 2){
			//⵽֮ľ
			double deltad[2] = {0};
			for(int j = 0; j < 2;j ++){
				double d[2] = {0};
				double dx1 = xcross[j] - pRP->x[0];
				double dy1 = ycross[j] - pRP->y[0];
				d[0] = sqrt(pow(dx1,2) + pow(dy1,2));

				double dx2 = xcross[j] - pRP->x[1];
				double dy2 = ycross[j] - pRP->y[1];
				d[1] = sqrt(pow(dx2,2) + pow(dy2,2));

				deltad[j] = d[0] - d[1];
			}

			int idx = 0;	

			//Ӧú֮ǰdistͬ
			if(distance > 0){
				for(int j = 0;j < 2;j++){
					if(deltad[j] > 0){
						idx = j;
						break;
					}
				}	
			}else{
				for(int j = 0;j < 2;j++){
					if(deltad[j] < 0){
						idx = j;
						break;
					}
				}	
			}
			res[nResIdx].x = xcross[idx];
			res[nResIdx].y = ycross[idx];
			res[nResIdx].z = zcross[idx];
			//nResIdx = idx;
		}		
		continue;
	}

	p->posx = res[nResIdx].x;
	p->posy = res[nResIdx].y;
	p->posz = res[nResIdx].z;

	return p;
}

/*
 * TDOA㷨ʵ
 * GetPos
 *		ʵֱߺ˫󽻵
 * param
 *		pRP    ------ վ·
 *      dist   ------ 
 *      i	   ------ i߶
 *
 * return
 *      Ľ⣬
 *
*/
RESULT* LocateAlgorithm::GetPos(ReaderPath * pRP,double dist,int i)
{
	//ĸ
	int count = 0;

	//
	double x[2] = {INVALID_COORDINATE,INVALID_COORDINATE};
	double y[2] = {INVALID_COORDINATE,INVALID_COORDINATE};

	//˫ߵֱ
	double x1 = pRP->x[0];
	double y1 = pRP->y[0];

	double x2 = pRP->x[1];
	double y2 = pRP->y[1];

	//ReaderPath * pRP = trpm.find(start.reader_id)->second.find(end.reader_id)->second;
	if(pRP->px[i] - pRP->px[i+1] == 0){
		//xȣ˫Y
		x[0] = x[1] = pRP->px[i];
		y[0] = (y1 + y2 + dist)/2.0;
		y[1] = (y1 + y2 - dist)/2.0;
		count = 2;
	}
	else{
		//˫ߺֱཻ
		//ֱ߳
		double k = (pRP->py[i+1] - pRP->py[i])/(pRP->px[i+1] - pRP->px[i]);
		double kb = pRP->py[i] - k*pRP->px[i];

		//ĳм
		double d1 = 2*(x2 - x1);//m
		//double d2 = 2*(y1 + y2);//n
		double d2 = 2*(y2 - y1);//n
		double d3 = pow(y1,2) + pow(x1,2)- pow(dist,2) - pow(y2,2)  - pow(x2,2);//p
		//ax^2 + bx + c = 0
		double a = pow(d1 + d2*k,2) - 4*pow(dist,2)*(pow(k,2) + 1);
		double b = 2*((d3 + d2*kb)*(d1 + d2*k) - 4*pow(dist,2)*(k*(kb - y2) - x2));
		double c = pow(d3 + d2*kb,2) - 4*pow(dist,2)*(pow(x2,2) + pow(kb-y2,2));

		double delta = pow(b,2) - 4*a*c;
		if(delta > 0){
			count = 2;
		}
		else if(delta == 0){
			count = 1;
		}
		else{
			count = 0;
		}

		if(count == 0){
			return NULL;
		}

		//
		x[0] = -(b + sqrt(delta))/(2*a);
		x[1] = (-b + sqrt(delta) )/(2*a);
		y[0] = k*x[0] + kb;
		y[1] = k*x[1] + kb;	
	}
	int nIdx = 0;
	int nValidCount = count;
	//
	double deviation = 0.0;
	//жǷ߶ηΧ
	if(count > 0){
		for(int t = 0; t < count ;t++){
			//վ֮i߶ε˵
			if(x[t] < min(pRP->px[i],pRP->px[i+1]) - deviation||
			   x[t] > max(pRP->px[i],pRP->px[i+1]) + deviation||
			   y[t] < min(pRP->py[i],pRP->py[i+1]) - deviation||
			   y[t] > max(pRP->py[i],pRP->py[i+1]) + deviation
				)
			{
				x[t] = INVALID_COORDINATE;
				y[t] = INVALID_COORDINATE;
				nValidCount--;
				nIdx = t;
			}
		}
	}
	
	RESULT* result = new RESULT;
	memset(result->x,0,3*sizeof(double));
	memset(result->y,0,3*sizeof(double));
	//memset(result->z,0,3*sizeof(double));
	result->nCount = 0;
	
	result->nCount = nValidCount;
	//result->z[0] = 0;
	//result->z[1] = 0;

	nIdx = -1;
	switch(nValidCount){
	case 1:
		for(int i = 0;i<2;i++){
			if(x[i] != INVALID_COORDINATE && y[i] != INVALID_COORDINATE){
				nIdx = i;
			}
		}
		result->x[0] = x[nIdx];
		result->y[0] = y[nIdx];
		break;
	case 2:
		result->x[0] = x[0];
		result->x[1] = x[1];
		result->y[0] = y[0];
		result->y[1] = y[1];
		break;
	}

	return result;
}

/*
 * жڵͼ
 *
 * param
 *		pos   ------		λĽ
 *		trpm  ------		ͼ
 *
 * return
 *		falseڵͼϣtrueڵͼ
 *
*/
bool LocateAlgorithm::IsOnMap(POS* pos,TDOAReaderPathMap trpm)
{
	//ͼжҲ˷վʼĵͼͷfalse
	if(trpm.find(pos->nFirstReader) == trpm.end()){
		return false;
	}

	//ͼҲվĵͼͷfalse
	if(trpm.find(pos->nFirstReader)->second->find(pos->nSecondReader) == trpm.find(pos->nFirstReader)->second->end())
	{
		return false;
	}

	//վ
	double x[2] = {0};
	double y[2] = {0};

	for(int i=0;i<2;i++){
		x[i] = trpm.find(pos->nFirstReader)->second->find(pos->nSecondReader)->second->x[i];
		y[i] = trpm.find(pos->nFirstReader)->second->find(pos->nSecondReader)->second->y[i];
	}

	if(x[0] == x[1]){
		//1cm
		if(abs(pos->posx - x[0]) > 1E-2){
			return false;
		}
	}else{
		double k = (y[1] - y[0])/(x[1] - x[0]);
		double b = y[1] - k*x[1];

		double calc_y = k*pos->posx + b;

		if(abs(calc_y - pos->posy) > 1E-2){
			return false;
		}
	}
	
	return true;
}

bool LocateAlgorithm::CheckPosInValid(POS* pos,ReceiveDataMap* pRdm,double dScale)
{
	if(dScale <= 0.0){
		return false;
	}

	if(pos->posx == INVALID_COORDINATE || pos->posy == INVALID_COORDINATE){
		return false;
	}
	//жϽЧ
	int nSize = 0;
	bool bRet = false;

	nSize = pRdm->size();
	double dist[2] = {0.0};

	if(nSize == 2){
		int i = 0;
		for(ReceiveDataMap::iterator it = pRdm->begin();it!=pRdm->end();++it,i++){
			dist[i] = sqrt(pow(pos->posx - it->second.x,2)+pow(pos->posy - it->second.y,2));
			if(fabs(dist[i]) < 4){
				//ڷΧڣжϴ˷վǷվ
				if(it->second.special){
					bRet = false;
				}else{
					bRet = true;
				}	
			}
		}	
	}

	//if(nSize >= 3){
	//	//ҳδ붨λķվ
	//	ReceiveDataMap::iterator f_it = pRdm->end();
	//	ReceiveDataMap::iterator it = pRdm->begin();
	//	int readers[2] = {0};
	//	readers[0] = pos->nFirstReader;
	//	readers[1] = pos->nSecondReader;

	//	for(it;it!=pRdm->end();++it){
	//		for(int i=0;i<2;i++){
	//			if(it->first == readers[i]){
	//				f_it = pRdm->end();
	//				break;
	//			}else{
	//				f_it = it;
	//			}
	//		}
	//	}

	//	if(f_it != pRdm->end()){
	//		ReceiveDataMap::iterator it = pRdm->find(pos->nFirstReader);

	//		dist[0] = sqrt(pow(pos->posx - it->second.x,2) + pow(pos->posy - it->second.y,2)) / dScale;
	//		dist[1] = sqrt(pow(pos->posx - f_it->second.x,2) + pow(pos->posy - f_it->second.y,2)) / dScale;

	//		double dif1 = dist[0] - dist[1];

	//		double dt = it->second.rec_time_stamp - f_it->second.rec_time_stamp;
	//		double dif2 = CFunctions::getDistance(dt,CFunctions::TDOA);

	//		double dif = fabs(dif1 - dif2);

	//		if(dif - 1 <= 1E-4){
	//			bRet = true;
	//		}

	//	}
	//}

	return bRet;
}

void HeapSort(_coordinate** pCoordinateArray,int nLen)
{
	BuildMaxHeap(pCoordinateArray,nLen);
	
	for(int i = nLen - 1;i > 0;i--){
		SwapElement(pCoordinateArray[0],pCoordinateArray[i]);
		AdjustMaxHeap(pCoordinateArray,0,i-1);
	}
}

void BuildMaxHeap(_coordinate** pCoordinateArray,int nLen)
{
	for(int i = nLen/2 - 1;i > 0;i--){
		AdjustMaxHeap(pCoordinateArray,i,nLen-1);
	}
}

void AdjustMaxHeap(_coordinate** pCoordinateArray,int n,int nHeapSize)
{
	int l = (n+1)*2-1;
	int r = (n+1)*2;

	int max;

	if(l <= nHeapSize && pCoordinateArray[l]->tt > pCoordinateArray[n]->tt){
		max = l;
	}else{
		max = n;
	}

	if(r <= nHeapSize && pCoordinateArray[r]->tt > pCoordinateArray[max]->tt){
		max = r;
	}

	if(max != n){
		SwapElement(pCoordinateArray[n],pCoordinateArray[max]);
		AdjustMaxHeap(pCoordinateArray,max,nHeapSize);
	}
}

void SwapElement(_coordinate* a,_coordinate*b)
{
	_coordinate tmp;
	tmp = *a;
	*a = *b;
	*b = tmp;
}

void SelectSort(_coordinate** pCoordinateArray,int nLen)
{  
    for (int i=0; i<nLen; i++)  
    {  
        int k = i;  
        unsigned long long key = pCoordinateArray[i]->tt;  
        for (int j=i+1; j<nLen; j++)  
        {  
            if (pCoordinateArray[j]->tt < key) 
            {  
                k = j;  
                key = pCoordinateArray[j]->tt;  
            }  
        }  
        if (k!=i)  
            SwapElement(pCoordinateArray[i], pCoordinateArray[k]);  
    }  
}  
